<template>
  <div id="CreateOrEditMovementSignForm">
    <v-form ref="formCreateOrEditMovementSign">
      <v-container>
        <!--Status-->
        <v-row>
          <v-col cols="12">
            <v-checkbox
              color="success"
              v-model="form.status"
              :label="
                form.status
                  ? $t('global.status.title') +
                    ': ' +
                    $t('global.status.aproved')
                  : $t('global.status.title') +
                    ': ' +
                    $t('global.status.pending')
              "
            ></v-checkbox>
          </v-col>
        </v-row>

        <v-divider class="mb-4"></v-divider>

        <!--Video/Image-->
        <v-row>
          <v-col cols="12">
            <p
              class="body-1-sistem family-openSans-bold mb-0 system_grey_3--text"
            >
              {{ $t("global.annex") }}
            </p>
          </v-col>
        </v-row>

        <v-row>
          <!--Video-->
          <v-col cols="12" md="6">
            <p class="body-1-sistem family-openSans-bold system_grey_3--text">
              {{ $t("signs.sign_video") }}
            </p>

            <VideoPlayerUtils
              :video_props="currentValue.video.video"
              v-if="is_edit"
            />

            <FileUpload
              acceptedTypes="video/*"
              :currentFile="videoFile"
              @successPost="saveVideoFile"
              @successDelete="deleteVideoFile"
              @submitStatusLoaderNewFile="getStatusLoaderNewFile"
              :currentVideoUrl="current.video_url"
              v-if="!is_edit"
            />
          </v-col>

          <!--Image-->
          <v-col cols="12" md="6">
            <p class="body-1-sistem family-openSans-bold system_grey_3--text">
              {{ $t("signs.image_riwth_sign_frame") }}
              <DetailsTooltipUtils icon="mdi-help-circle-outline mb-1" />
            </p>

            <FileUpload
              acceptedTypes=".png, .jpg, .jpeg"
              :currentImageUrl="current.img"
              @successPost="saveImageFile"
              @successDelete="deleteImageFile"
              @submitStatusLoaderNewFile="getStatusLoaderNewFile"
              :currentFile="imageFile"
              v-if="!is_edit"
            />

            <template v-if="is_edit">
              <ImageAvatar
                :image_props="currentValue.imagem.url"
                v-if="currentValue.imagem"
              />
            </template>
          </v-col>
        </v-row>

        <v-divider class="mb-4"></v-divider>

        <!--Basic properties-->
        <v-row>
          <!--Title-->
          <v-col cols="12">
            <h4 class="body-1-sistem family-openSans-bold cursor-pointer mb-0">
              {{ $t("signs.basic_properties") }}
            </h4>
          </v-col>

          <!-- Glosa -->
          <v-col cols="12" md="6">
            <!--Default-->
            <template>
              <label
                class="body-1-sistem family-openSans-bold cursor-pointer"
                for="glosa"
              >
                {{ $t("signs.gloss_id") }}
              </label>

              <DetailsTooltipUtils icon="mdi-help-circle-outline mb-1" />

              <v-text-field
                id="glosa"
                outlined
                type="text"
                v-model="form.glosa"
                :rules="[
                  verifyMaxLengthMixin(form.glosa, 255),
                  verifyDataRequiredMixin(form.glosa),
                ]"
                hide-details="auto"
                class="mb-4"
              ></v-text-field>
            </template>

            <!--Translate-->
            <p class="body-1-sistem family-openSans-bold">
              {{ $t("global.translate_other_languages") }}
            </p>

            <div
              v-for="(language, index) in form.traducao"
              :key="index + 'glosa'"
            >
              <label
                class="body-1-sistem family-openSans-bold cursor-pointer"
                :for="'glosa' + index"
              >
                {{ $t("signs.gloss_id") }} - {{ index }}

                <span class="family-openSans-regular">
                  ({{ $t("global.optional") }})
                </span>
              </label>

              <v-text-field
                :id="'glosa' + index"
                outlined
                type="text"
                v-model="form.traducao[index].glosa"
                :rules="[verifyMaxLengthMixin(form.traducao[index].glosa, 255)]"
                hide-details="auto"
              ></v-text-field>
            </div>
          </v-col>

          <!--Lemma-->
          <v-col cols="12" md="6">
            <!--Default-->
            <template>
              <label
                class="body-1-sistem family-openSans-bold cursor-pointer"
                for="glosa"
              >
                {{ $t("signs.lemma") }}
              </label>
              <DetailsTooltipUtils icon="mdi-help-circle-outline mb-1" />

              <v-text-field
                id="glosa"
                outlined
                type="text"
                v-model="form.lema"
                :rules="[
                  verifyMaxLengthMixin(form.lema, 255),
                  verifyDataRequiredMixin(form.lema),
                ]"
                hide-details="auto"
                class="mb-4"
              ></v-text-field>
            </template>

            <!--Translate-->
            <p class="body-1-sistem family-openSans-bold">
              {{ $t("global.translate_other_languages") }}
            </p>

            <div
              v-for="(language, index) in form.traducao"
              :key="index + 'lemma'"
            >
              <label
                class="body-1-sistem family-openSans-bold cursor-pointer"
                :for="'glosa' + index"
              >
                {{ $t("signs.lemma") }} - {{ index }}

                <span class="family-openSans-regular">
                  ({{ $t("global.optional") }})
                </span>
              </label>

              <v-text-field
                :id="'glosa' + index"
                outlined
                type="text"
                v-model="form.traducao[index].lema"
                :rules="[verifyMaxLengthMixin(form.traducao[index].lema, 255)]"
              ></v-text-field>
            </div>
          </v-col>
        </v-row>

        <v-divider class="mb-4"></v-divider>

        <!--Syntax-->
        <v-row>
          <!--Title-->
          <v-col cols="12">
            <h4
              class="body-1-sistem family-openSans-bold cursor-pointer mb-0 system_grey_3--text"
            >
              {{ $t("signs.syntax") }}
            </h4>
          </v-col>

          <!--Word class-->
          <v-col cols="12">
            <template>
              <label
                class="body-1-sistem family-openSans-bold cursor-pointer system_grey_3--text"
                for="word_class"
              >
                {{ $t("signs.categories.word_class") }}
              </label>

              <DetailsTooltipUtils icon="mdi-help-circle-outline mb-1" />

              <v-autocomplete
                outlined
                :items="word_class"
                id="word_class"
                item-text="nome"
                :label="$t('global.select')"
                v-model="form.classe_da_palavra"
                disabled
              ></v-autocomplete>
            </template>
          </v-col>
        </v-row>

        <v-divider class="mb-4"></v-divider>

        <!--Movements-->
        <v-row>
          <!--Title-->
          <v-col cols="12">
            <h4 class="body-1-sistem family-openSans-bold cursor-pointer mb-0">
              {{ $t("signs.movement") }}
            </h4>
          </v-col>

          <!--Movement shape-->
          <v-col cols="12" md="6">
            <template>
              <label
                class="body-1-sistem family-openSans-bold cursor-pointer system_grey_3--text"
                for="movement_shape"
              >
                {{ $t("signs.categories.movement_shape") }}
              </label>

              <DetailsTooltipUtils icon="mdi-help-circle-outline mb-1" />

              <v-autocomplete
                outlined
                :items="word_class"
                id="movement_shape"
                item-text="nome"
                :label="$t('global.select')"
                v-model="form.forma_do_movimento"
                disabled
              ></v-autocomplete>
            </template>
          </v-col>

          <!--Repeated movement/Alternating movement-->
          <v-col cols="12" md="6">
            <v-container class="pt-0">
              <v-row>
                <!--Repeated movement-->
                <v-col cols="12" md="6">
                  <label
                    class="body-1-sistem family-openSans-bold cursor-pointer"
                    for="repeated_movement"
                  >
                    {{ $t("signs.categories.repeated_movement") }}
                  </label>

                  <DetailsTooltipUtils icon="mdi-help-circle-outline mb-1" />

                  <v-radio-group v-model="form.movimento_repetido">
                    <v-radio
                      :label="$t('global.status.yes')"
                      :value="true"
                    ></v-radio>

                    <v-radio
                      :label="$t('global.status.no')"
                      :value="false"
                    ></v-radio>
                  </v-radio-group>
                </v-col>

                <!--Movimento alternado-->
                <v-col cols="12" md="6">
                  <label
                    class="body-1-sistem family-openSans-bold cursor-pointer"
                    for="repeated_movement"
                  >
                    {{ $t("signs.categories.alternating_movement") }}
                  </label>

                  <DetailsTooltipUtils icon="mdi-help-circle-outline mb-1" />

                  <v-radio-group v-model="form.movimento_alternado">
                    <v-radio
                      :label="$t('global.status.yes')"
                      :value="true"
                    ></v-radio>

                    <v-radio
                      :label="$t('global.status.no')"
                      :value="false"
                    ></v-radio>
                  </v-radio-group>
                </v-col>
              </v-row>
            </v-container>
          </v-col>
        </v-row>

        <!--Author and Responsible-->
        <v-row v-if="is_edit">
          <v-col cols="12" sm="6" md="5" lg="3" xl="2">
            <SummaryAuthorCard :people_props="form.autor" v-if="form.autor" />
          </v-col>
          <v-col cols="12" sm="6" md="5" lg="3" xl="2">
            <SummaryResponsibleCard
              :people_props="form.aprovador"
              v-if="form.aprovador"
            />
          </v-col>
        </v-row>

        <!--Buttons-->
        <v-row>
          <v-col cols="12">
            <div class="text-center">
              <!--Delete-->
              <v-btn
                outlined
                rounded
                color="error"
                depressed
                @click.stop.prevent="dialogDelete = true"
                class="mb-2"
              >
                <span class="family-openSans-bold">
                  {{ $t("buttons.delete") }}
                </span>
              </v-btn>

              <!--Back-->
              <v-btn
                outlined
                @click="localePath($router.go(-1))"
                rounded
                color="info"
                depressed
                class="mb-2"
              >
                <span class="family-openSans-bold">
                  {{ $t("buttons.back") }}
                </span>
              </v-btn>

              <!--Submit-->
              <v-btn
                depressed
                rounded
                color="warning"
                @click.stop.prevent="submitForm()"
                class="family-openSans-bold mb-2"
                :loading="loadingForm"
              >
                <span class="family-openSans-bold">
                  {{ currentValue ? $t("buttons.edit") : $t("buttons.create") }}
                </span>
              </v-btn>
            </div>
          </v-col>
        </v-row>
      </v-container>
    </v-form>

    <v-dialog v-if="dialogDelete" max-width="800px" v-model="dialogDelete">
      <v-card>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn icon color="system_grey_3" @click="dialogDelete = false">
            <v-icon>mdi-close</v-icon>
          </v-btn>
        </v-card-actions>
        <v-card-text class="px-0"> DeleteFaqModal </v-card-text>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
import ValidationFormsMixin from "@/mixins/Forms/ValidationFormsMixin.vue";
import TranslateMixin from "@/mixins/Global/TranslateMixin.vue";
import SummaryResponsibleCard from "@/components/Cards/Users/SummaryResponsibleCard.vue";
import SummaryAuthorCard from "@/components/Cards/Users/SummaryAuthorCard.vue";
import DetailsTooltipUtils from "@/components/Utils/Global/DetailsTooltipUtils.vue";
import FileUpload from "@/components/Form/Global/FileUploadForms.vue";
import ImageAvatar from "@/components/Avatar/Global/ImageAvatar.vue";
import VideoPlayerUtils from "@/components/Utils/Videos/PlayerVideosUtils.vue";

export default {
  props: ["currentValue"],

  mixins: [ValidationFormsMixin, TranslateMixin],

  components: {
    SummaryResponsibleCard,
    SummaryAuthorCard,
    DetailsTooltipUtils,
    FileUpload,
    ImageAvatar,
    VideoPlayerUtils,
  },

  data() {
    return {
      loadingForm: false,
      is_edit: false,

      word_class: [{ nome: "Exemplo" }],

      videoFile: null,
      imageFile: null,
      loadingNewFile: false,
      current: {
        video_url: "",
        img: "",
      },

      form: {
        status: false,
        glosa: "",

        traducao: null,
        movimento_repetido: false,
        movimento_alternado: false,

        // dados que precisariam de relacionamentos, mas não é a proposta inicial dessa entrega
        classe_da_palavra: null,
        forma_do_movimento: null,
        autor: null,
        aprovador: null,
        video: null,
        imagem: null,
      },

      form_data_translate: {
        glosa: "",
        lema: "",
      },

      dialogDelete: false,

      aprovador_fake: {
        imagem: {
          alt: "Senhora branca de cabelo curto",
          url: "https://www.shutterstock.com/image-photo/head-shot-close-portrait-happy-260nw-1667439787.jpg",
        },
        nome: "Glória Vieira",
      },
      autor_fake: {
        imagem: {
          alt: "Mulher branca com cabelo preso",
          url: "https://www.shutterstock.com/image-photo/happy-young-indian-woman-blogger-260nw-1606121245.jpg",
        },
        nome: "Maria Teixeira",
      },
      image_fake: {
        alt: "",
        url: "https://www.shutterstock.com/image-photo/portrait-deaf-black-woman-office-600w-2262358103.jpg",
      },
      video_fake: {
        thumb:
          "https://www.shutterstock.com/shutterstock/videos/1099847493/thumb/1.jpg?ip=x480",
        video:
          "https://www.shutterstock.com/shutterstock/videos/1099847493/preview/stock-footage-learning-disability-sign-language-in-video-conference.webm",
      },
    };
  },

  mounted() {
    this.addTranslateInFormMixin();

    if (this.currentValue) {
      this.form = Object.assign({}, this.currentValue);
      this.is_edit = true;
    }
  },

  watch: {
    "form.status": function (val) {
      if (val) {
        this.form.aprovador = this.aprovador_fake;
      }

      if (!val) {
        this.form.aprovador = null;
      }
    },
  },

  methods: {
    getStatusLoaderNewFile(statusLoader) {
      this.loadingNewFile = statusLoader;
    },

    submitForm() {
      if (!this.$refs.formCreateOrEditMovementSign.validate()) {
        this.$toast.error(
          this.$t("global.mensager.api_mensager.information_no_correct")
        );
      }

      if (this.$refs.formCreateOrEditMovementSign.validate()) {
        if (this.currentValue) {
          this.edit();
        } else {
          this.post();
        }
      }
    },

    edit() {
      this.loadingForm = true;

      this.$axios
        .put(`sinais/${this.currentValue.id}`, this.form)
        .then(() => {
          this.$toast.success(this.$t("global.mensager.api_mensager.success"));
          this.$router.push(
            this.localePath("/dashboard/signs", this.$i18n.locale)
          );
        })
        .catch(() => {
          this.$toast.error(this.$t("global_message_alerts.error_edit"));
        })
        .finally(() => {
          this.loadingForm = false;
        });
    },

    post() {
      this.loadingForm = true;

      this.form.imagem = this.image_fake;
      this.form.video = this.video_fake;
      this.form.autor = this.autor_fake;

      this.$axios
        .post(`sinais`, this.form)
        .then(() => {
          this.$toast.success(this.$t("global.mensager.api_mensager.success"));
          this.$router.push(
            this.localePath("/dashboard/signs", this.$i18n.locale)
          );
        })
        .catch(() => {
          this.$toast.error(this.$t("global.mensager.api_mensager.error"));
        })
        .finally(() => {
          this.loadingForm = false;
        });
    },

    // Sign Video
    saveVideoFile(file) {
      this.videoFile = file;
      this.form.video = this.videoFile;
    },

    deleteVideoFile() {
      this.videoFile = undefined;
      this.form.video = null;
    },

    // Sign Image
    saveImageFile(file) {
      this.imageFile = file;
      this.form.imagem = this.imageFile.url;
    },

    deleteImageFile() {
      this.imageFile = undefined;
      this.form.imagem = null;
    },
  },
};
</script>
